# Class RowProtocol

java.lang.Object
org.mariadb.jdbc.internal.com.read.resultset.rowprotocol.RowProtocol

Direct Known Subclasses:
  `BinaryRowProtocol, TextRowProtocol`

public abstract class RowProtocol extends Object

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`BIT_LAST_FIELD_NOT_NULL`
`static final int`
`BIT_LAST_FIELD_NULL`
`static final int`
`BIT_LAST_ZERO_DATE`
`byte[]`
`buf`
`protected int`
`index`
`static final Pattern`
`isIntegerRegex`
`int`
`lastValueNull`
`int`
`length`
`protected final int`
`maxFieldSize`
`protected static final int`
`NULL_LENGTH`
`protected final Options`
`options`
`int`
`pos`
`static final DateTimeFormatter`
`TEXT_LOCAL_DATE_TIME`
`static final DateTimeFormatter`
`TEXT_OFFSET_DATE_TIME`
`static final DateTimeFormatter`
`TEXT_ZONED_DATE_TIME`
`static final int`
`TINYINT1_IS_BIT`
`static final int`
`YEAR_IS_DATE_TYPE`

## Constructor Summary

Constructors
Constructor
Description
`RowProtocol(int maxFieldSize, Options options)`

## Method Summary

Modifier and Type
Method
Description
`protected int`
`extractNanos(String timestring)`
`abstract BigDecimal`
`getInternalBigDecimal(ColumnDefinition columnInfo)`
`abstract BigInteger`
`getInternalBigInteger(ColumnDefinition columnInfo)`
`abstract boolean`
`getInternalBoolean(ColumnDefinition columnInfo)`
`abstract byte`
`getInternalByte(ColumnDefinition columnInfo)`
`abstract Date`
`getInternalDate(ColumnDefinition columnInfo, Calendar cal, TimeZone timeZone)`
`abstract double`
`getInternalDouble(ColumnDefinition columnInfo)`
`abstract float`
`getInternalFloat(ColumnDefinition columnInfo)`
`abstract int`
`getInternalInt(ColumnDefinition columnInfo)`
`abstract LocalDate`
`getInternalLocalDate(ColumnDefinition columnInfo, TimeZone timeZone)`
`abstract LocalTime`
`getInternalLocalTime(ColumnDefinition columnInfo, TimeZone timeZone)`
`abstract long`
`getInternalLong(ColumnDefinition columnInfo)`
`protected long`
`getInternalMediumInt(ColumnDefinition columnInfo)`
`abstract Object`
`getInternalObject(ColumnDefinition columnInfo, TimeZone timeZone)`
`abstract OffsetTime`
`getInternalOffsetTime(ColumnDefinition columnInfo, TimeZone timeZone)`
`abstract short`
`getInternalShort(ColumnDefinition columnInfo)`
`protected int`
`getInternalSmallInt(ColumnDefinition columnInfo)`
`abstract String`
`getInternalString(ColumnDefinition columnInfo, Calendar cal, TimeZone timeZone)`
`abstract Time`
`getInternalTime(ColumnDefinition columnInfo, Calendar cal, TimeZone timeZone)`
`abstract Timestamp`
`getInternalTimestamp(ColumnDefinition columnInfo, Calendar userCalendar, TimeZone timeZone)`
`abstract String`
`getInternalTimeString(ColumnDefinition columnInfo)`
`protected int`
`getInternalTinyInt(ColumnDefinition columnInfo)`
`abstract ZonedDateTime`
`getInternalZonedDateTime(ColumnDefinition columnInfo, Class clazz, TimeZone timeZone)`
`int`
`getLengthMaxFieldSize()`
`int`
`getMaxFieldSize()`
`abstract boolean`
`isBinaryEncoded()`
`boolean`
`lastValueWasNull()`
`protected long`
`parseBit()`
`protected void`
`rangeCheck(Object className, long minValue, long maxValue, long value, ColumnDefinition columnInfo)`
`protected void`
`rangeCheck(Object className, long minValue, long maxValue, BigDecimal value, ColumnDefinition columnInfo)`
`void`
`resetRow(byte[] buf)`
`abstract void`
`setPosition(int position)`
`boolean`
`wasNull()`
Reports whether the last column read had a value of Null.
`protected String`
`zeroFillingIfNeeded(String value, ColumnDefinition columnDefinition)`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### BIT_LAST_FIELD_NOT_NULL

public static final int BIT_LAST_FIELD_NOT_NULL

See Also:
  - Constant Field Values

### BIT_LAST_FIELD_NULL

public static final int BIT_LAST_FIELD_NULL

See Also:
  - Constant Field Values

### BIT_LAST_ZERO_DATE

public static final int BIT_LAST_ZERO_DATE

See Also:
  - Constant Field Values

### TINYINT1_IS_BIT

public static final int TINYINT1_IS_BIT

See Also:
  - Constant Field Values

### YEAR_IS_DATE_TYPE

public static final int YEAR_IS_DATE_TYPE

See Also:
  - Constant Field Values

### TEXT_LOCAL_DATE_TIME

public static final DateTimeFormatter TEXT_LOCAL_DATE_TIME

### TEXT_OFFSET_DATE_TIME

public static final DateTimeFormatter TEXT_OFFSET_DATE_TIME

### TEXT_ZONED_DATE_TIME

public static final DateTimeFormatter TEXT_ZONED_DATE_TIME

### isIntegerRegex

public static final Pattern isIntegerRegex

### NULL_LENGTH

protected static final int NULL_LENGTH

See Also:
  - Constant Field Values

### maxFieldSize

protected final int maxFieldSize

### options

protected final Options options

### lastValueNull

public int lastValueNull

### buf

public byte[] buf

### pos

public int pos

### length

public int length

### index

protected int index

## Constructor Details

### RowProtocol

public RowProtocol(int maxFieldSize, Options options)

## Method Details

### resetRow

public void resetRow(byte[] buf)

### setPosition

public abstract void setPosition(int position)

### getLengthMaxFieldSize

public int getLengthMaxFieldSize()

### getMaxFieldSize

public int getMaxFieldSize()

### getInternalString

public abstract String getInternalString(ColumnDefinition columnInfo, Calendar cal, TimeZone timeZone) throws SQLException

Throws:
  `SQLException`

### getInternalInt

public abstract int getInternalInt(ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### getInternalLong

public abstract long getInternalLong(ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### getInternalFloat

public abstract float getInternalFloat(ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### getInternalDouble

public abstract double getInternalDouble(ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### getInternalBigDecimal

public abstract BigDecimal getInternalBigDecimal(ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### getInternalDate

public abstract Date getInternalDate(ColumnDefinition columnInfo, Calendar cal, TimeZone timeZone) throws SQLException

Throws:
  `SQLException`

### getInternalTime

public abstract Time getInternalTime(ColumnDefinition columnInfo, Calendar cal, TimeZone timeZone) throws SQLException

Throws:
  `SQLException`

### getInternalTimestamp

public abstract Timestamp getInternalTimestamp(ColumnDefinition columnInfo, Calendar userCalendar, TimeZone timeZone) throws SQLException

Throws:
  `SQLException`

### getInternalObject

public abstract Object getInternalObject(ColumnDefinition columnInfo, TimeZone timeZone) throws SQLException

Throws:
  `SQLException`

### getInternalBoolean

public abstract boolean getInternalBoolean(ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### getInternalByte

public abstract byte getInternalByte(ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### getInternalShort

public abstract short getInternalShort(ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### getInternalTimeString

public abstract String getInternalTimeString(ColumnDefinition columnInfo)

### getInternalBigInteger

public abstract BigInteger getInternalBigInteger(ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### getInternalZonedDateTime

public abstract ZonedDateTime getInternalZonedDateTime(ColumnDefinition columnInfo, Class clazz, TimeZone timeZone) throws SQLException

Throws:
  `SQLException`

### getInternalOffsetTime

public abstract OffsetTime getInternalOffsetTime(ColumnDefinition columnInfo, TimeZone timeZone) throws SQLException

Throws:
  `SQLException`

### getInternalLocalTime

public abstract LocalTime getInternalLocalTime(ColumnDefinition columnInfo, TimeZone timeZone) throws SQLException

Throws:
  `SQLException`

### getInternalLocalDate

public abstract LocalDate getInternalLocalDate(ColumnDefinition columnInfo, TimeZone timeZone) throws SQLException

Throws:
  `SQLException`

### isBinaryEncoded

public abstract boolean isBinaryEncoded()

### lastValueWasNull

public boolean lastValueWasNull()

### zeroFillingIfNeeded

protected String zeroFillingIfNeeded(String value, ColumnDefinition columnDefinition)

### getInternalTinyInt

protected int getInternalTinyInt(ColumnDefinition columnInfo)

### parseBit

protected long parseBit()

### getInternalSmallInt

protected int getInternalSmallInt(ColumnDefinition columnInfo)

### getInternalMediumInt

protected long getInternalMediumInt(ColumnDefinition columnInfo)

### rangeCheck

protected void rangeCheck(Object className, long minValue, long maxValue, BigDecimal value, ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### rangeCheck

protected void rangeCheck(Object className, long minValue, long maxValue, long value, ColumnDefinition columnInfo) throws SQLException

Throws:
  `SQLException`

### extractNanos

protected int extractNanos(String timestring) throws SQLException

Throws:
  `SQLException`

### wasNull

public boolean wasNull()
Reports whether the last column read had a value of Null. Note that you must first call one of the getter methods on a column to try to read its value and then call the method wasNull to see if the value read was Null.

Returns:
  true true if the last column value read was null and false otherwise